
var chart,chartInfo,mapData,arrData,datOHCL,datClose ;
var avg_1_last,avg_2_last,avg_3_last,datOHCL_last ;

var M_CHART_LINE  = 0 ;
var M_CHART_KBAR  = 1 ;
var M_HISRQ_RELOAD = '0' ;
var M_HISRQ_UPDATE = '1' ;

var indexOHLC = {
    Time : 0,
    Open : 1,
    High : 2,
    Low : 3,
    Close : 4
};

var seriesKey = {
    lineMast : 'lineMast',
    lineAvg  : 'lineAvg',
    ohlcMast : 'ohlcMast',
    ohlcAvg1 : 'ohlcAvg1',
    ohlcAvg2 : 'ohlcAvg2',
    ohlcAvg3 : 'ohlcAvg3',
    indexMACD: 'indexMACD',
    indexSignal : 'indexSignal',
    indexHistogram : 'indexHistogram'
};

var seriesOptions = [] ;
var sk  = seriesKey ;

seriesOptions[sk.lineMast] = {
    name    : '分时',
    id      : sk.lineMast ,
    type    : 'line',
    color   : '#AAAAAA',
    data    : [],
    lineWidth: 2,
    tooltip : {enabled:false,valueDecimals: 2}
} ;

seriesOptions[sk.lineAvg]  = {
    name    : '均线－30',
    id      : sk.lineAvg ,
    type    : 'line',
    data    : [],
    lineWidth: 1,
    tooltip : {enabled:false,valueDecimals: 2}
} ;

seriesOptions[sk.ohlcAvg1] = {
    name    : '均线－10',
    id      : sk.ohlcAvg1 ,
    type    : 'line',
    data    : [],
    lineWidth: 1,
    tooltip : {enabled:false,valueDecimals: 2}
} ;

seriesOptions[sk.ohlcAvg2] = {
    name    : '均线－20',
    id      : sk.ohlcAvg2 ,
    type    : 'line',
    data    : [],
    lineWidth: 1,
    tooltip : {enabled:false,valueDecimals: 2}
} ;

seriesOptions[sk.ohlcAvg3] = {
    name    : '均线－30',
    id      : sk.ohlcAvg3 ,
    type    : 'line',
    data    : [],
    lineWidth: 1,
    tooltip : {enabled:false,valueDecimals: 2}
} ;

seriesOptions[sk.ohlcMast] = {
    name    : 'K线',
    id      : sk.ohlcMast ,
    type    : 'candlestick', // area, areaspline, bar, column, line, pie, scatter, spline, candlestick or ohlc
    data    : [],
    tooltip : {enabled:false,valueDecimals: 2}
} ;

function loadData(symbolCode) {};

function updateLastPoint(data) {};




/**
 * @brief               计算算数平均值
 * @param arr
 * @returns {number}
 */
function arrayAvg (arr) {
    var sum = 0,
    arrLength = arr.length,
    i = arrLength;
    
    while (i--) {
        sum = sum + arr[i];
    }
    
    return (sum / arrLength);
}

/** Function based on the idea of an exponential moving average.
 *
 * Formula: EMA = Price(t) * k + EMA(y) * (1 - k)
 * t = today, y = yesterday, N = number of days in EMA, k = 2/(2N+1)
 *
 * @param yData : array of y variables.
 * @param xData : array of x variables.
 * @param periods : The amount of "days" to average from.
 * @return an array containing the EMA.
 **/
function EMA (xData, yData, periods) {
    
    var t,
    y = false,
    n = periods,
    k = (2 / (n + 1)),
    ema,	// exponential moving average.
    emLine = [],
    periodArr = [],
    length = yData.length,
    pointStart = xData[0];
    
    // loop through data
    for (var i = 0; i < length; i++) {
        
        
        // Add the last point to the period arr, but only if its set.
        if (yData[i-1]) {
            periodArr.push(yData[i]);
        }
        
        
        // 0: runs if the periodArr has enough points.
        // 1: set currentvalue (today).
        // 2: set last value. either by past avg or yesterdays ema.
        // 3: calculate todays ema.
        if (n == periodArr.length) {
            
            
            t = yData[i];
            
            if (!y) {
                y = arrayAvg(periodArr);
            } else {
                ema = (t * k) + (y * (1 - k));
                y = ema;
            }
            
            emLine.push([xData[i] , y]);
            
            // remove first value in array.
            periodArr.splice(0,1);
            
        } else {
            
            emLine.push([xData[i] , null]);
        }
        
    }
    
    return emLine;
}

/**
 * @brief               将 Epoch 时间格式转换成 日期型
 * @param mEpoch
 * @returns {Date}
 * @constructor
 */
function Epoch2Date (mEpoch){
    
    var dDate =new Date() ;
    
    if( mEpoch<10000000000 ){
        mEpoch *= 1000;
    } // convert to milliseconds (Epoch is usually expressed in seconds, but Javascript uses Milliseconds)
    
    dDate.setTime(mEpoch);
    return dDate;
}

function setSeriesData (key,data) {
    var series = chart.get(key) ;
    if (series) {
        series.setData(data,true) ;
    }
}

function addSeriesData (key,data) {
    var series = chart.get(key) ;
    if (series) {
        series.addPoint(data,true) ;
    }
}

// 设置数轴
function getSeries(chartType) {
        var me = this ;
        var sk = me.seriesKey ;
        var ret = [];

        switch (chartType)
        {
            case M_CHART_LINE :
            {
                ret = [
                    seriesOptions[sk.lineMast],
                    seriesOptions[sk.lineAvg]
                ] ;

                break ;
            }
            case M_CHART_KBAR :
            {
                ret = [
                    seriesOptions[sk.ohlcAvg1],
                    seriesOptions[sk.ohlcAvg2],
                    seriesOptions[sk.ohlcAvg3],
                    seriesOptions[sk.ohlcMast]
                ] ;
                break ;
            }
            default : {}
        }

        return ret ;
}

// 设置Y轴
function getYAxis(chartType) {
    var result;
    
    switch (chartType)
    {
        case M_CHART_LINE :
        {
            result = [
                      {
                      gridLineColor: '#333333',
                      title: {
                      text: 'Price'
                      },
                      labels: {
                      align: 'left',
                      format: '{value:.2f}'
                      },
                      allowDecimals: true,
                      height: '100%',
                      offset: 0,
                      lineWidth: 1
                      }
                      
                      ];
            
            break ;
        }
        case M_CHART_KBAR :
        {
            result = [
                      {
                      gridLineColor: '#333333',
                      title: {
                      text: 'Price'
                      },
                      labels: {
                      align: 'left'
                      //format: '{value:.0f}'
                      },
                      allowDecimals: true,
                      // tickInterval:0.50,
                      height: '100%',
                      offset: 0,
                      lineWidth: 1
                      }
                      //{
                      //    title: {
                      //        text: 'MACD'
                      //    },
                      //    labels: {
                      //        align: 'left',
                      //        format: '{value:.2f}'
                      //    },
                      //    top: '72%',
                      //    height: '30%',
                      //    offset: 5,
                      //    lineWidth: 1
                      //}
                      ];
            break ;
        }
        default : {}
    }
    
    return result;
}

// 设置主题颜色
function setTheme() {
    
    Highcharts.theme = {
    colors: [
             "#aaaa00",
             "#a98db7",
             "#0f6ea0",
             "#aaaa00",
             "#a98db7",
             "#009900",
             "#eeaaee",
             "#55BF3B",
             "#DF5353",
             "#7798BF",
             "#aaeeee"
             ],
        
    chart: {
    backgroundColor: {
    linearGradient: { x1: 0, y1: 0, x2: 1, y2: 1 },
    stops: [
            [ 0, '#1E1E1E' ], // #252525 , #2a2a2b , #1a232b
            [ 1, '#1E1E1E' ]  // #252525 , #3e3e40
            ]
    },
    style: {
    fontFamily: "'Unica One', sans-serif"
    },
    plotBorderColor: '#606063'
    },
    title: {
    style: {
    color: '#E0E0E3',
    textTransform: 'uppercase',
    fontSize: '20px'
    }
    },
    subtitle: {
    style: {
    color: '#E0E0E3',
    textTransform: 'uppercase'
    }
    },
    xAxis: {
    gridLineColor: '#707073',
    labels: {
    style: {
    color: '#E0E0E3'
    }
    },
    lineColor: '#707073',
    minorGridLineColor: '#505053',
    tickColor: '#707073',
    title: {
    style: {
    color: '#A0A0A3'
        
    }
    }
    },
    yAxis: {
    gridLineColor: '#707073',
    labels: {
    style: {
    color: '#E0E0E3'
    }
    },
    lineColor: '#707073',
    minorGridLineColor: '#505053',
    tickColor: '#707073',
    tickWidth: 1,
    title: {
    style: {
    color: '#A0A0A3'
    }
    }
    },
    tooltip: {
    backgroundColor: 'rgba(0, 0, 0, 0.85)',
    style: {
    color: '#F0F0F0'
    }
    },
    plotOptions: {
    series: {
    dataLabels: {
    color: '#B0B0B3'
    },
    marker: {
    lineColor: '#333'
    }
    },
    boxplot: {
    fillColor: '#000099'
    },
    candlestick: {
    color: '#408E50', //M_COLOR_PRICE_FALL,         // 阴柱 33AA33 / 408E50
    lineColor: '#408E50', //M_COLOR_PRICE_FALL,    // bar border line Color
    upColor: '#DD3333', //M_COLOR_PRICE_RISE,         // 阳柱
    upLineColor: '#DD3333'  //M_COLOR_PRICE_RISE
    },
    errorbar: {
    color: 'white'
    },
    costPrice: {"win" : '#B34F48',"lose" : '#408E50'},
    closePrice:{"color" : '#7CABC6'}
    },
    legend: {
    itemStyle: {
    color: '#E0E0E3'
    },
    itemHoverStyle: {
    color: '#FFF'
    },
    itemHiddenStyle: {
    color: '#606063'
    }
    },
    credits: {
    style: {
    color: '#666'
    }
    },
    labels: {
    style: {
    color: '#707073'
    }
    },
        
    drilldown: {
    activeAxisLabelStyle: {
    color: '#F0F0F3'
    },
    activeDataLabelStyle: {
    color: '#F0F0F3'
    }
    },
        
    navigation: {
    buttonOptions: {
    symbolStroke: '#DDDDDD',
    theme: {
    fill: '#505053'
    }
    }
    },
        
        // scroll charts
    rangeSelector: {
    buttonTheme: {
    fill: '#505053',
    stroke: '#000000',
    style: {
    color: '#CCC'
    },
    states: {
    hover: {
    fill: '#707073',
    stroke: '#000000',
    style: {
    color: 'white'
    }
    },
    select: {
    fill: '#000003',
    stroke: '#000000',
    style: {
    color: 'white'
    }
    }
    }
    },
    inputBoxBorderColor: '#505053',
    inputStyle: {
    backgroundColor: '#1E1E1E', // #333
    color: 'silver'
    },
    labelStyle: {
    color: 'silver'
    }
    },
        
    navigator: {
    handles: {
    backgroundColor: '#666',
    borderColor: '#AAA'
    },
    outlineColor: '#CCC',
    maskFill: 'rgba(255,255,255,0.1)',
    series: {
    color: '#7798BF',
    lineColor: '#A6C7ED'
    },
    xAxis: {
    gridLineColor: '#505053'
    }
    },
        
    scrollbar: {
    barBackgroundColor: '#808083',
    barBorderColor: '#808083',
    buttonArrowColor: '#CCC',
    buttonBackgroundColor: '#606063',
    buttonBorderColor: '#606063',
    rifleColor: '#FFF',
    trackBackgroundColor: '#404043',
    trackBorderColor: '#404043'
    },
        
        // special colors for some of the
    legendBackgroundColor: 'rgba(0, 0, 0, 0.5)',
    background2: '#505053',
    dataLabelsColor: '#B0B0B3',
    textColor: '#C0C0C0',
    contrastTextColor: '#F0F0F3',
    maskColor: 'rgba(255,255,255,0.3)'
    } ;
    
//    Highcharts.theme = {
//    colors: ["#2b908f", "#90ee7e", "#f45b5b", "#7798BF", "#aaeeee", "#ff0066", "#eeaaee",
//             "#55BF3B", "#DF5353", "#7798BF", "#aaeeee"],
//    chart: {
//    backgroundColor: {
//    linearGradient: { x1: 0, y1: 0, x2: 1, y2: 1 },
//    stops: [
//            [0, '#2a2a2b'],
//            [1, '#3e3e40']
//            ]
//    },
//    style: {
//    fontFamily: "'Unica One', sans-serif"
//    },
//    plotBorderColor: '#606063'
//    },
//    title: {
//    style: {
//    color: '#E0E0E3',
//    textTransform: 'uppercase',
//    fontSize: '20px'
//    }
//    },
//    subtitle: {
//    style: {
//    color: '#E0E0E3',
//    textTransform: 'uppercase'
//    }
//    },
//    xAxis: {
//    gridLineColor: '#707073',
//    labels: {
//    style: {
//    color: '#E0E0E3'
//    }
//    },
//    lineColor: '#707073',
//    minorGridLineColor: '#505053',
//    tickColor: '#707073',
//    title: {
//    style: {
//    color: '#A0A0A3'
//        
//    }
//    }
//    },
//    yAxis: {
//    gridLineColor: '#707073',
//    labels: {
//    style: {
//    color: '#E0E0E3'
//    }
//    },
//    lineColor: '#707073',
//    minorGridLineColor: '#505053',
//    tickColor: '#707073',
//    tickWidth: 1,
//    title: {
//    style: {
//    color: '#A0A0A3'
//    }
//    }
//    },
//    tooltip: {
//    backgroundColor: 'rgba(0, 0, 0, 0.85)',
//    style: {
//    color: '#F0F0F0'
//    }
//    },
//    plotOptions: {
//    series: {
//    dataLabels: {
//    color: '#B0B0B3'
//    },
//    marker: {
//    lineColor: '#333'
//    }
//    },
//    boxplot: {
//    fillColor: '#505053'
//    },
//    candlestick: {
//    lineColor: 'white'
//    },
//    errorbar: {
//    color: 'white'
//    }
//    },
//    legend: {
//    itemStyle: {
//    color: '#E0E0E3'
//    },
//    itemHoverStyle: {
//    color: '#FFF'
//    },
//    itemHiddenStyle: {
//    color: '#606063'
//    }
//    },
//    credits: {
//    style: {
//    color: '#666'
//    }
//    },
//    labels: {
//    style: {
//    color: '#707073'
//    }
//    },
//        
//    drilldown: {
//    activeAxisLabelStyle: {
//    color: '#F0F0F3'
//    },
//    activeDataLabelStyle: {
//    color: '#F0F0F3'
//    }
//    },
//        
//    navigation: {
//    buttonOptions: {
//    symbolStroke: '#DDDDDD',
//    theme: {
//    fill: '#505053'
//    }
//    }
//    },
//        
//        // scroll charts
//    rangeSelector: {
//    buttonTheme: {
//    fill: '#505053',
//    stroke: '#000000',
//    style: {
//    color: '#CCC'
//    },
//    states: {
//    hover: {
//    fill: '#707073',
//    stroke: '#000000',
//    style: {
//    color: 'white'
//    }
//    },
//    select: {
//    fill: '#000003',
//    stroke: '#000000',
//    style: {
//    color: 'white'
//    }
//    }
//    }
//    },
//    inputBoxBorderColor: '#505053',
//    inputStyle: {
//    backgroundColor: '#333',
//    color: 'silver'
//    },
//    labelStyle: {
//    color: 'silver'
//    }
//    },
//        
//    navigator: {
//    handles: {
//    backgroundColor: '#666',
//    borderColor: '#AAA'
//    },
//    outlineColor: '#CCC',
//    maskFill: 'rgba(255,255,255,0.1)',
//    series: {
//    color: '#7798BF',
//    lineColor: '#A6C7ED'
//    },
//    xAxis: {
//    gridLineColor: '#505053'
//    }
//    },
//        
//    scrollbar: {
//    barBackgroundColor: '#808083',
//    barBorderColor: '#808083',
//    buttonArrowColor: '#CCC',
//    buttonBackgroundColor: '#606063',
//    buttonBorderColor: '#606063',
//    rifleColor: '#FFF',
//    trackBackgroundColor: '#404043',
//    trackBorderColor: '#404043'
//    },
//        
//        // special colors for some of the
//    legendBackgroundColor: 'rgba(0, 0, 0, 0.5)',
//    background2: '#505053',
//    dataLabelsColor: '#B0B0B3',
//    textColor: '#C0C0C0',
//    contrastTextColor: '#F0F0F3',
//    maskColor: 'rgba(255,255,255,0.3)'
//    };
    
    // Apply the theme
    Highcharts.setOptions(Highcharts.theme);
}

// 绘图数据预处理
function buildData(data,chartInfo) {
    
    // data 的数据格式，[[time,open,high,low,close], [time,open,high,low,close], ...]
    
    chartInfo.addCount = 0 ;  // 非常重要：这里必须初始化 addCount ,该值用于表示本次请求得到的数据有多少笔是新增的
    
    switch (chartInfo.reDrawType)
    {
        case M_HISRQ_RELOAD :
        {// 重新加载数据
            
            arrData = data ;
            mapData = [] ;
            // 记录时间值与数组索引的对应关系，在增量模式下可以根据时间值查找数组项，执行更新
            for (var i=0; i<data.length; i++)
            {
                var time  = data[i][indexOHLC.Time].toString() ;
                mapData[time] = i ;
            }
            break ;
        }
        case M_HISRQ_UPDATE :
        {// 增量加载数据
            
            for (var i=0; i<data.length; i++) {
                var time  = data[i][indexOHLC.Time].toString() ;
                var index = mapData[time] ; // 在现有的行情里查询是否已经有数据，有则执行更新，无则执行添加
                
                if ((typeof index)==='undefined') {
                
                    chartInfo.addCount ++ ;  // 记录增量的数据条目数
                    arrData.push(data[i]) ;
                    mapData[time] = arrData.length-1 ;

                }else{
                    // 在缓存中找到对应的数据项，执行更新操作
                    var cacheData = arrData[index] ;
                    
                    cacheData[indexOHLC.Open]  = data[i][indexOHLC.Open] ;
                    cacheData[indexOHLC.High]  = data[i][indexOHLC.High] ;
                    cacheData[indexOHLC.Low]   = data[i][indexOHLC.Low] ;
                    cacheData[indexOHLC.Close] = data[i][indexOHLC.Close] ;

                    // cacheData.set('high',  record.get('high')) ;
                    // cacheData.set('low',   record.get('low')) ;
                    // cacheData.set('close', record.get('close')) ;
                    // cacheData.set('volume',record.get('volume')) ;
                    // cacheData.set('amount',record.get('amount')) ;
                }
            }
            
            break ;
        }
        default : {}
    }
}

function testDraw(strData) {
    // alert('OK');
    var data = eval('(' + strData + ')' ) ;
    //var data = getTestData() ;
    chartInfo.reDrawType = M_HISRQ_RELOAD ;
    
    // var tmp = Epoch2Date(data[data.length-1][0]) ;
    // alert(tmp) ;
    
    reDraw(data,chartInfo) ;
}

function reDraw(data,chartInfo) {
    // data 的数据格式，[[time,open,high,low,close], [time,open,high,low,close], ...]
    buildData(data,chartInfo) ; // 这里的处理回更新 me.store

    
    if (chart) {
        
        // var sk = me.seriesKey ;
        // var chart = me.chart ;
        var symbolInfo = chartInfo.symbolInfo ;
        
        // 设置图表的区域范围
        var btn          = {} ;
        var range        = {min:0,max:0} ;
        var tradeDayLine = [] ;  // 以交易日为分界的信息
        var bandRange    = {start:0,end:0} ;  // 记录数据中的开收市时间段
        
        // K 线数据
        datOHCL  = [] ;  // K线数据
        datClose = [] ;  // 分时图数据
        
        // 移动平均线参数
        var j           = 0;
        var avg_1       = [] ;
        var periodArr_1 = [];
        var periods_1   = 10 ;
        
        var avg_2       = [] ;
        var periodArr_2 = [];
        var periods_2   = 20 ;
        
        var avg_3       = [] ;
        var periodArr_3 = [];
        var periods_3   = 30 ;
        
        var xData       = [] ;
        var yData       = [] ;

        var middleIndex = parseInt(arrData.length * 2 / 3) ;
        
        for (var i=0; i<arrData.length; i++) {
            
            var item = arrData[i] ;
            
            if ( parseInt(i) == middleIndex ) {
                range.min = item[indexOHLC.Time] * 1000 ;
            }
            
            var curTM = item[indexOHLC.Time] * 1000 ;
            range.max = curTM ;
            chartInfo.lastDate = item[indexOHLC.Time] ;  // 记录得到的历史行情数据的最后一笔数据的时间，用于增量请求
            
            // ---------------------------------------------------------
            // 判断开市/收市时间
            // ---------------------------------------------------------
            if (bandRange.start!==0 && curTM < symbolInfo.beginTime ) {
                // bandRange.start 不为0，且时间仍小于开市时间，表示当前时间curTM还是属于上个交易日的
                bandRange.end = curTM ;   // 记录下上个交易日数据的结束坐标值
            }
            if ( curTM < symbolInfo.beginTime  && bandRange.start===0 ) {
                bandRange.start = curTM ; // 记录下上个交易日数据的开始坐标值
            }
            
            // ---------------------------------------------------------
            // 初始化 K 线数据
            // ---------------------------------------------------------
            var point = [];
            // [time, open, high, low, close]
            
            var qTm   =  Epoch2Date(item[indexOHLC.Time]) ;
            
            point.push(item[indexOHLC.Time] * 1000 ) ;
            point.push(item[indexOHLC.Open]) ;
            point.push(item[indexOHLC.High]) ;
            point.push(item[indexOHLC.Low]) ;
            point.push(item[indexOHLC.Close]) ;
            
            // K 线数据
            datOHCL.push(point) ;
            
            // 分时图数据
            datClose.push([item[indexOHLC.Time] * 1000,close]) ;
            
            if ( j>0 ) {
                
                var lastOpen  = datOHCL[i-1][1] ;
                var lastHigh  = datOHCL[i-1][2] ;
                var lastLow   = datOHCL[i-1][3] ;
                var lastClose = datOHCL[i-1][4] ;
            }

            // ---------------------------------------------------------
            // 计算移动平均线
            // ---------------------------------------------------------
            var time  = item[indexOHLC.Time] * 1000;
            var close = item[indexOHLC.Close];
            var mavg  = 0 ;
            
            periodArr_1.push(close);
            periodArr_2.push(close);
            periodArr_3.push(close);
            
            var startCalcIndex = i - periods_1 + 1;
            if (startCalcIndex < 0) {
                avg_1.push([time, null]);
            } else {
                mavg = arrayAvg(periodArr_1);
                avg_1.push( [time, mavg] );
                periodArr_1.splice(0, 1);
            }
            
            startCalcIndex = i - periods_2 + 1;
            if (startCalcIndex < 0) {
                avg_2.push([time, null]);
            } else {
                mavg = arrayAvg(periodArr_2);
                avg_2.push( [time, mavg] );
                periodArr_2.splice(0, 1);
            }
            
            startCalcIndex = i - periods_3 + 1;
            if (startCalcIndex < 0) {
                avg_3.push([time, null]);
            } else {
                mavg = arrayAvg(periodArr_3);
                avg_3.push( [time, mavg] );
                periodArr_3.splice(0, 1);
            }
            
            j++;
        
            // ---------------------------------------------------------
            // 初始化 MACD
            // ---------------------------------------------------------
            xData.push(time);
            yData.push(close);

        }
        
        
        // ---------------------------------------------------------
        // 计算 MACD
        // ---------------------------------------------------------
        // MACD 指标参数
        var MACD        = [] ;
        var xMACD       = [] ;
        var yMACD       = [] ;
        var histogram   = [] ;
        var signalLine  = [] ;
        var shortPeriod = 12,longPeriod = 26,signalPeriod = 9 ;
        var shortEMA,longEMA ;
        // Calculating the short and long EMA used when calculating the MACD
        shortEMA = EMA(xData, yData, shortPeriod);
        longEMA  = EMA(xData, yData, longPeriod);
        
        // subtract each Y value from the EMA's and create the new dataset (MACD)
        for (var i = 0; i < shortEMA.length; i++) {
            
            if (longEMA[i][1] == null) {
                
                MACD.push([ xData[i] , null ]);
                
            } else {
                MACD.push([ xData[i] , (shortEMA[i][1] - longEMA[i][1]) ]);
            }
            
            xMACD.push(MACD[i][0]);
            yMACD.push(MACD[i][1]);
            
        }
        
        // Set the Y and X data of the MACD. This is used in calculating the signal line.
        //for (var i = 0; i < MACD.length; i++) {
        //}
        
        // Setting the signalline (Signal Line: X-day EMA of MACD line).
        signalLine = EMA(xMACD, yMACD, signalPeriod);
        
        // Setting the MACD Histogram. In comparison to the loop with pure MACD this loop uses MACD x value not xData.
        for (var i = 0; i < MACD.length; i++) {
            
            if (MACD[i][1] == null) {
                
                histogram.push([ MACD[i][0], null ]);
                
            } else {
                
                histogram.push([ MACD[i][0], (MACD[i][1] - signalLine[i][1]) ]);
                
            }
        }
        
        var setData = function() {
            
            switch (chartInfo.ChartType)
            {
                case M_CHART_LINE :
                {
                    setSeriesData(sk.lineAvg,avg_2) ;
                    setSeriesData(sk.lineMast,datClose) ;
                    break ;
                }
                case M_CHART_KBAR :
                {
                    setSeriesData(sk.ohlcAvg1,avg_1) ;
                    setSeriesData(sk.ohlcAvg2,avg_2) ;
                    setSeriesData(sk.ohlcAvg3,avg_3) ;
                    setSeriesData(sk.ohlcMast,datOHCL) ;
                    break ;
                }
                default : {}
            }
        }; // addSeriesData
        
        //try {
        
        switch (chartInfo.reDrawType)
        {
            case M_HISRQ_RELOAD :
            {
                chartInfo.reDrawType = M_HISRQ_UPDATE ;     // 变更方式，下次处理数据时按增量模式处理
                
                setData() ;
                switch (chartInfo.ChartType)
                {
                    case M_CHART_LINE :
                    {
                        chart.xAxis[0].setExtremes();
                        break ;
                    }
                    case M_CHART_KBAR :
                    {
                        chart.xAxis[0].setExtremes(range.min,range.max,true);
                        break ;
                    }
                    default : {}
                }
                break ;
            }
            case M_HISRQ_UPDATE :
            {
                var addDataIndex = arrData.length - chartInfo.addCount ;
                for (var i = addDataIndex-1; i<arrData.length; i++) {
                    if ( avg_1_last[0] == avg_1[i][0] ) {
                    } else {
                        switch (chartInfo.ChartType)
                        {
                            case M_CHART_LINE :
                            {
                                addSeriesData(sk.lineAvg,avg_2[i],true) ;
                                addSeriesData(sk.lineMast,datClose[i],true) ;
                                break ;
                            }
                            case M_CHART_KBAR :
                            {
                                addSeriesData(sk.ohlcAvg1,avg_1[i],true) ;
                                addSeriesData(sk.ohlcAvg2,avg_2[i],true) ;
                                addSeriesData(sk.ohlcAvg3,avg_3[i],true) ;
                                addSeriesData(sk.ohlcMast,datOHCL[i],true) ;
                                //me.chart.xAxis[0].setExtremes(range.min,range.max,true);
                                break ;
                            }
                            default : {}
                        }
                    }
                    setData() ;
                }
                break ;
            }
            default : {}
        }
        
        avg_1_last   = avg_1[avg_1.length-1] ;
        avg_2_last   = avg_2[avg_2.length-1] ;
        avg_3_last   = avg_3[avg_3.length-1] ;
        datOHCL_last = datOHCL[datOHCL.length-1] ;
        
        //addPlotLine(M_PLOT_CLOSEPRICE) ;
        //addPlotLine(M_PLOT_BUYCOST) ;
        //addPlotLine(M_PLOT_SELLCOST) ;
        
        //if (bandRange.end===0){
        //    bandRange.end = Date2Epoch(new Date()) * 1000 ;
        //}
        
        //me.addPlotBand(bandRange) ;
        chart.redraw() ;
        // delayTask(function(){me.chart.redraw() ;},100) ;
        
    }
}

function getTestData(){
    
    var testData = [[1421289360,1.523600,1.523800,1.523400,1.523600],[1421289420,1.523600,1.523600,1.523300,1.523500],[1421289480,1.523400,1.523600,1.523300,1.523500],[1421289540,1.523600,1.523600,1.523400,1.523400],[1421289600,1.523500,1.523600,1.523300,1.523500],[1421289660,1.523500,1.523600,1.523500,1.523500],[1421289720,1.523500,1.523600,1.523300,1.523400],[1421289780,1.523500,1.523600,1.523300,1.523400],[1421289840,1.523400,1.523600,1.523300,1.523400],[1421289900,1.523600,1.523600,1.523300,1.523500],[1421289960,1.523500,1.523600,1.523200,1.523500],[1421290020,1.523600,1.523600,1.523300,1.523400],[1421290080,1.523400,1.523600,1.523300,1.523400],[1421290140,1.523400,1.523600,1.523200,1.523400],[1421290200,1.523200,1.523400,1.523200,1.523300],[1421290260,1.523300,1.523300,1.523000,1.523300],[1421290320,1.523300,1.523400,1.523000,1.523300],[1421290380,1.523300,1.523400,1.523000,1.523300],[1421290440,1.523200,1.523400,1.523000,1.523200],[1421290500,1.523200,1.523400,1.523200,1.523200],[1421290560,1.523300,1.523400,1.523000,1.523200],[1421290620,1.523200,1.523400,1.523000,1.523400],[1421290680,1.523300,1.523400,1.523000,1.523300],[1421290740,1.523200,1.523400,1.523200,1.523200],[1421290800,1.523300,1.523500,1.523300,1.523400],[1421290860,1.523300,1.523500,1.523300,1.523400],[1421290920,1.523400,1.523500,1.523200,1.523400],[1421290980,1.523200,1.523500,1.523200,1.523500],[1421291040,1.523400,1.523500,1.523200,1.523300],[1421291100,1.523300,1.523400,1.523000,1.523300],[1421291160,1.523300,1.523400,1.523200,1.523300],[1421291220,1.523400,1.523400,1.523200,1.523300],[1421291280,1.523300,1.523400,1.523200,1.523300],[1421291340,1.523300,1.523500,1.523200,1.523300],[1421291400,1.523300,1.523500,1.523300,1.523400],[1421291460,1.523300,1.523500,1.523200,1.523500],[1421291520,1.523500,1.523700,1.523300,1.523700],[1421291580,1.523600,1.523800,1.523500,1.523600],[1421291640,1.523600,1.523800,1.523500,1.523500],[1421291700,1.523600,1.523700,1.523400,1.523600],[1421291760,1.523600,1.523700,1.523500,1.523700],[1421291820,1.523500,1.523800,1.523500,1.523600],[1421291880,1.523600,1.523800,1.523500,1.523500],[1421291940,1.523700,1.523800,1.523500,1.523700],[1421292000,1.523800,1.523800,1.523500,1.523700],[1421292060,1.523800,1.523800,1.523500,1.523700],[1421292120,1.523600,1.523700,1.523400,1.523500],[1421292180,1.523600,1.523600,1.523400,1.523600],[1421292240,1.523500,1.523700,1.523400,1.523600],[1421292300,1.523500,1.523700,1.523500,1.523700],[1421292360,1.523600,1.523900,1.523500,1.523900],[1421292420,1.523800,1.524000,1.523700,1.523900],[1421292480,1.523800,1.524000,1.523700,1.523900],[1421292540,1.523900,1.524000,1.523700,1.523800],[1421292600,1.523700,1.523900,1.523600,1.523800],[1421292660,1.523800,1.523900,1.523700,1.523900],[1421292720,1.523800,1.524000,1.523700,1.523800],[1421292780,1.523800,1.524100,1.523800,1.524000],[1421292840,1.524000,1.524100,1.523900,1.524000],[1421292900,1.524100,1.524100,1.523700,1.523800],[1421292960,1.524100,1.524100,1.523800,1.523800],[1421293020,1.523900,1.524100,1.523700,1.523800],[1421293080,1.523800,1.524100,1.523700,1.523800],[1421293140,1.524100,1.524100,1.523600,1.523700],[1421293200,1.523600,1.523800,1.523600,1.523800],[1421293260,1.523800,1.523800,1.523600,1.523700],[1421293320,1.523500,1.523800,1.523400,1.523500],[1421293380,1.523600,1.523600,1.523200,1.523500],[1421293440,1.523300,1.523600,1.523300,1.523300],[1421293500,1.523600,1.523600,1.523300,1.523300],[1421293560,1.523300,1.523600,1.523200,1.523400],[1421293620,1.523300,1.523600,1.523300,1.523600],[1421293680,1.523300,1.523600,1.523300,1.523400],[1421293740,1.523400,1.523600,1.523200,1.523400],[1421293800,1.523600,1.523600,1.523300,1.523300],[1421293860,1.523300,1.523600,1.523200,1.523300],[1421293920,1.523400,1.523600,1.523200,1.523300],[1421293980,1.523200,1.523600,1.523000,1.523500],[1421294040,1.523400,1.523600,1.523300,1.523500],[1421294100,1.523400,1.523600,1.523300,1.523300],[1421294160,1.523400,1.523700,1.523400,1.523600],[1421294220,1.523500,1.523700,1.523300,1.523300],[1421294280,1.523400,1.523600,1.523400,1.523600],[1421294340,1.523700,1.523700,1.523300,1.523600],[1421294400,1.523500,1.523700,1.523400,1.523600],[1421294460,1.523700,1.523800,1.523500,1.523800],[1421294520,1.523700,1.523900,1.523600,1.523700],[1421294580,1.523800,1.523800,1.523700,1.523700],[1421294640,1.523800,1.523800,1.523600,1.523600],[1421294700,1.523800,1.523800,1.523600,1.523600],[1421294760,1.523800,1.524100,1.523600,1.524100],[1421294820,1.524000,1.524100,1.523900,1.523900],[1421294880,1.523900,1.524100,1.523900,1.524000],[1421294940,1.524000,1.524100,1.523800,1.523900],[1421295000,1.523700,1.524000,1.523700,1.523800],[1421295060,1.523800,1.524000,1.523600,1.523800],[1421295120,1.523800,1.524000,1.523800,1.524000],[1421295180,1.523800,1.524000,1.523800,1.523800],[1421295240,1.523800,1.523900,1.523700,1.523800],[1421295300,1.523800,1.524000,1.523800,1.523900],[1421295360,1.523800,1.524000,1.523700,1.523800],[1421295420,1.523800,1.524000,1.523800,1.523800],[1421295480,1.523800,1.524000,1.523800,1.523900],[1421295540,1.524000,1.524000,1.523600,1.523700],[1421295600,1.523600,1.523800,1.523500,1.523700],[1421295660,1.523700,1.523900,1.523600,1.523800],[1421295720,1.523700,1.524000,1.523700,1.523800],[1421295780,1.523700,1.524000,1.523700,1.524000],[1421295840,1.523900,1.524000,1.523800,1.523800],[1421295900,1.523900,1.524000,1.523600,1.523700],[1421295960,1.523900,1.523900,1.523500,1.523700],[1421296020,1.523900,1.523900,1.523500,1.523700],[1421296080,1.523600,1.523700,1.523500,1.523600],[1421296140,1.523600,1.523700,1.523300,1.523600],[1421296200,1.523700,1.523700,1.523400,1.523500],[1421296260,1.523400,1.523700,1.523400,1.523500],[1421296320,1.523500,1.523700,1.523400,1.523400],[1421296380,1.523400,1.523700,1.523400,1.523400],[1421296440,1.523700,1.523700,1.523300,1.523400],[1421296500,1.523400,1.523500,1.523200,1.523500],[1421296560,1.523500,1.523600,1.523300,1.523400],[1421296620,1.523500,1.523500,1.523300,1.523500],[1421296680,1.523400,1.523500,1.523300,1.523400],[1421296740,1.523400,1.523400,1.523000,1.523000],[1421296800,1.523000,1.523300,1.523000,1.523000],[1421296860,1.523000,1.523200,1.522900,1.523200],[1421296920,1.523200,1.523500,1.523000,1.523500],[1421296980,1.523400,1.523500,1.523200,1.523400],[1421297040,1.523400,1.523600,1.523200,1.523200],[1421297100,1.523300,1.523400,1.523200,1.523400],[1421297160,1.523400,1.523400,1.523000,1.523300],[1421297220,1.523400,1.523400,1.523200,1.523300],[1421297280,1.523200,1.523400,1.523000,1.523400],[1421297340,1.523400,1.523400,1.523200,1.523400],[1421297400,1.523300,1.523400,1.523200,1.523400],[1421297460,1.523200,1.523400,1.523200,1.523200],[1421297520,1.523300,1.523400,1.523000,1.523000],[1421297580,1.523000,1.523200,1.522900,1.523000],[1421297640,1.523000,1.523200,1.523000,1.523200],[1421297700,1.523000,1.523300,1.523000,1.523000],[1421297760,1.523200,1.523300,1.523000,1.523200],[1421297820,1.523000,1.523200,1.523000,1.523200],[1421297880,1.523300,1.523300,1.522900,1.523200],[1421297940,1.523000,1.523300,1.523000,1.523000],[1421298000,1.523000,1.523400,1.523000,1.523200],[1421298060,1.523400,1.523500,1.523000,1.523000],[1421298120,1.523000,1.523300,1.522900,1.523000],[1421298180,1.522900,1.523000,1.522800,1.523000],[1421298240,1.522900,1.523000,1.522700,1.522900],[1421298300,1.522900,1.523000,1.522600,1.522900],[1421298360,1.522900,1.523000,1.522700,1.522800],[1421298420,1.522800,1.523000,1.522600,1.523000],[1421298480,1.523000,1.523000,1.522700,1.522900],[1421298540,1.522900,1.523000,1.522700,1.522800],[1421298600,1.522700,1.522900,1.522600,1.522700],[1421298660,1.522900,1.522900,1.522600,1.522800],[1421298720,1.522900,1.522900,1.522600,1.522600],[1421298780,1.522900,1.522900,1.522700,1.522800],[1421298840,1.522900,1.522900,1.522600,1.522600],[1421298900,1.522700,1.522900,1.522400,1.522400],[1421298960,1.522400,1.522700,1.522400,1.522600],[1421299020,1.522700,1.522700,1.522400,1.522500],[1421299080,1.522600,1.522700,1.522500,1.522700],[1421299140,1.522600,1.522700,1.522500,1.522500],[1421299200,1.522600,1.522900,1.522500,1.522600],[1421299260,1.522700,1.522800,1.522400,1.522600],[1421299320,1.522700,1.522800,1.522400,1.522700],[1421299380,1.522500,1.522900,1.522500,1.522900],[1421299440,1.522900,1.522900,1.522500,1.522700],[1421299500,1.522900,1.522900,1.522700,1.522700],[1421299560,1.522800,1.522900,1.522600,1.522800],[1421299620,1.522600,1.522800,1.522500,1.522500],[1421299680,1.522700,1.522800,1.522600,1.522600],[1421299740,1.522800,1.522800,1.522500,1.522600],[1421299800,1.522700,1.522800,1.522600,1.522800],[1421299860,1.522800,1.522800,1.522400,1.522600],[1421299920,1.522600,1.522700,1.522300,1.522500],[1421299980,1.522500,1.522800,1.522400,1.522600],[1421300040,1.522700,1.522700,1.522400,1.522700],[1421300100,1.522600,1.522700,1.522500,1.522500],[1421300160,1.522600,1.522700,1.522500,1.522600],[1421300220,1.522600,1.522800,1.522400,1.522700],[1421300280,1.522700,1.522800,1.522500,1.522700],[1421300340,1.522700,1.522800,1.522500,1.522700],[1421300400,1.522700,1.522900,1.522600,1.522800],[1421300460,1.522800,1.523000,1.522700,1.522800],[1421300520,1.522800,1.522900,1.522600,1.522700],[1421300580,1.522800,1.522900,1.522600,1.522700],[1421300640,1.522800,1.522900,1.522700,1.522900],[1421300700,1.522900,1.522900,1.522600,1.522700],[1421300760,1.522800,1.522900,1.522700,1.522700],[1421300820,1.522800,1.522900,1.522700,1.522800],[1421300880,1.522800,1.523000,1.522700,1.522800],[1421300940,1.522800,1.523000,1.522700,1.523000],[1421301000,1.522800,1.523000,1.522700,1.522700],[1421301060,1.522800,1.522900,1.522600,1.522900],[1421301120,1.522700,1.522900,1.522700,1.522900],[1421301180,1.522900,1.522900,1.522700,1.522800],[1421301240,1.522800,1.522800,1.522400,1.522600],[1421301300,1.522500,1.522600,1.522400,1.522500],[1421301360,1.522500,1.522700,1.522400,1.522600],[1421301420,1.522500,1.522700,1.522400,1.522600],[1421301480,1.522600,1.522600,1.522400,1.522500],[1421301540,1.522500,1.522700,1.522500,1.522500],[1421301600,1.522600,1.522700,1.522500,1.522700],[1421301660,1.522600,1.522700,1.522500,1.522600],[1421301720,1.522600,1.522700,1.522300,1.522600],[1421301780,1.522600,1.522600,1.522400,1.522500],[1421301840,1.522500,1.522800,1.522500,1.522600],[1421301900,1.522700,1.522700,1.522400,1.522400],[1421301960,1.522500,1.522700,1.522300,1.522400],[1421302020,1.522300,1.522600,1.522100,1.522200],[1421302080,1.522300,1.522400,1.522100,1.522200],[1421302140,1.522300,1.522400,1.522200,1.522400],[1421302200,1.522400,1.522500,1.522300,1.522400],[1421302260,1.522300,1.522400,1.522100,1.522300],[1421302320,1.522300,1.522500,1.522200,1.522400],[1421302380,1.522300,1.522600,1.522300,1.522400],[1421302440,1.522600,1.522600,1.522300,1.522400],[1421302500,1.522500,1.522600,1.522300,1.522600],[1421302560,1.522600,1.522600,1.522300,1.522300],[1421302620,1.522600,1.522600,1.522200,1.522300],[1421302680,1.522300,1.522600,1.522300,1.522500],[1421302740,1.522600,1.522600,1.522200,1.522300],[1421302800,1.522300,1.522500,1.522200,1.522300],[1421302860,1.522400,1.522400,1.522100,1.522300],[1421302920,1.522300,1.522400,1.522100,1.522400],[1421302980,1.522300,1.522400,1.522000,1.522300],[1421303040,1.522200,1.522400,1.522100,1.522200],[1421303100,1.522200,1.522500,1.522200,1.522300],[1421303160,1.522200,1.522600,1.522200,1.522500],[1421303220,1.522500,1.522600,1.522300,1.522400],[1421303280,1.522400,1.522600,1.522100,1.522500],[1421303340,1.522300,1.522500,1.522300,1.522400],[1421303400,1.522300,1.522500,1.522300,1.522500],[1421303460,1.522500,1.522600,1.522300,1.522400],[1421303520,1.522500,1.522500,1.522000,1.522300],[1421303580,1.522300,1.522400,1.522100,1.522200],[1421303640,1.522300,1.522300,1.522200,1.522200],[1421303700,1.522100,1.522300,1.522000,1.522000],[1421303760,1.522100,1.522200,1.522100,1.522100],[1421303820,1.522100,1.522300,1.522000,1.522100],[1421303880,1.522300,1.522300,1.521900,1.522100],[1421303940,1.522100,1.522300,1.522000,1.522100],[1421304000,1.522100,1.522300,1.522000,1.522200],[1421304060,1.522100,1.522300,1.522000,1.522200],[1421304120,1.522200,1.522200,1.522000,1.522200],[1421304180,1.522100,1.522200,1.522000,1.522100],[1421304240,1.522100,1.522300,1.522000,1.522200],[1421304300,1.522100,1.522300,1.522000,1.522200],[1421304360,1.522100,1.522300,1.522000,1.522100],[1421304420,1.522000,1.522300,1.522000,1.522200],[1421304480,1.522100,1.522200,1.522000,1.522100],[1421304540,1.522200,1.522300,1.521900,1.522100],[1421304600,1.522100,1.522200,1.522000,1.522100],[1421304660,1.522100,1.522400,1.522000,1.522200],[1421304720,1.522200,1.522400,1.522100,1.522400],[1421304780,1.522300,1.522500,1.522100,1.522300],[1421304840,1.522200,1.522400,1.521900,1.522100],[1421304900,1.522100,1.522200,1.521600,1.521700],[1421304960,1.521900,1.522000,1.521700,1.521800],[1421305020,1.521800,1.522000,1.521600,1.521900],[1421305080,1.521900,1.522000,1.521600,1.521800],[1421305140,1.521900,1.522000,1.521500,1.521500],[1421305200,1.521500,1.522000,1.521300,1.521300],[1421305260,1.521300,1.521600,1.521200,1.521600],[1421305320,1.521600,1.521900,1.521300,1.521800],[1421305380,1.521900,1.521900,1.521400,1.521700],[1421305440,1.521800,1.521800,1.521500,1.521600],[1421305500,1.521600,1.521800,1.521500,1.521600],[1421305560,1.521600,1.521700,1.521500,1.521700],[1421305620,1.521600,1.521900,1.521300,1.521800],[1421305680,1.521300,1.521600,1.521300,1.521500],[1421305740,1.521400,1.521600,1.521200,1.521400],[1421305800,1.521600,1.521600,1.521200,1.521300],[1421305860,1.521500,1.521600,1.521000,1.521400],[1421305920,1.521400,1.521500,1.521000,1.521200],[1421305980,1.521200,1.521400,1.521000,1.521200],[1421306040,1.521200,1.521400,1.520900,1.521400],[1421306100,1.521300,1.521400,1.521000,1.521300],[1421306160,1.521300,1.521300,1.520900,1.520900],[1421306220,1.521200,1.521200,1.520700,1.520900],[1421306280,1.520900,1.521200,1.520800,1.520900],[1421306340,1.520900,1.520900,1.520600,1.520900],[1421306400,1.520800,1.520800,1.520400,1.520500],[1421306460,1.520500,1.520700,1.520300,1.520400],[1421306520,1.520400,1.520800,1.520300,1.520600],[1421306580,1.520500,1.520900,1.520500,1.520900],[1421306640,1.520900,1.521200,1.520900,1.521000],[1421306700,1.521000,1.521400,1.520900,1.521400],[1421306760,1.521300,1.521400,1.520900,1.521200],[1421306820,1.521200,1.521200,1.520800,1.520800],[1421306880,1.520800,1.520900,1.520700,1.520900],[1421306940,1.520900,1.521000,1.520800,1.520900],[1421307000,1.521000,1.521600,1.520900,1.521200],[1421307060,1.521300,1.521600,1.521200,1.521400],[1421307120,1.521400,1.521500,1.521000,1.521300],[1421307180,1.521500,1.521900,1.521000,1.521900],[1421307240,1.521800,1.522200,1.521700,1.522200],[1421307300,1.522000,1.522200,1.521500,1.521700],[1421307360,1.521700,1.522000,1.521400,1.521500],[1421307420,1.521500,1.521600,1.521000,1.521200],[1421307480,1.521400,1.521500,1.520800,1.521300],[1421307540,1.521200,1.521400,1.520900,1.521200],[1421307600,1.521000,1.521500,1.520900,1.521500],[1421307660,1.521400,1.522000,1.521400,1.521700],[1421307720,1.521700,1.522000,1.521500,1.521700],[1421307780,1.521800,1.522100,1.521600,1.521600],[1421307840,1.521700,1.521900,1.521600,1.521900],[1421307900,1.521800,1.522100,1.521700,1.521900],[1421307960,1.521900,1.522600,1.521900,1.522500],[1421308020,1.522500,1.522500,1.521900,1.522200],[1421308080,1.522200,1.522300,1.521800,1.521800],[1421308140,1.522000,1.522100,1.521700,1.522000],[1421308200,1.522100,1.522100,1.521500,1.521500],[1421308260,1.521500,1.521700,1.521200,1.521600],[1421308320,1.521600,1.521800,1.521300,1.521400],[1421308380,1.521300,1.521400,1.521200,1.521300],[1421308440,1.521300,1.521700,1.521000,1.521200],[1421308500,1.521000,1.521500,1.521000,1.521400],[1421308560,1.521300,1.521700,1.521300,1.521600],[1421308620,1.521500,1.521900,1.521400,1.521700],[1421308680,1.521500,1.521800,1.521300,1.521600],[1421308740,1.521500,1.522000,1.521500,1.521800],[1421308800,1.521800,1.522000,1.521500,1.521800],[1421308860,1.521800,1.521800,1.521000,1.521000],[1421308920,1.521000,1.521500,1.520800,1.520900],[1421308980,1.520900,1.520900,1.520600,1.520700],[1421309040,1.520800,1.520900,1.520300,1.520500],[1421309100,1.520400,1.521200,1.520400,1.521000],[1421309160,1.520900,1.521400,1.520800,1.520900],[1421309220,1.520900,1.521000,1.520700,1.521000],[1421309280,1.520900,1.521200,1.520700,1.521000],[1421309340,1.520900,1.521300,1.520700,1.521000],[1421309400,1.520900,1.521400,1.520900,1.521300],[1421309460,1.521300,1.521600,1.520900,1.521500],[1421309520,1.521500,1.521700,1.521300,1.521500],[1421309580,1.521200,1.521600,1.521200,1.521200],[1421309640,1.521300,1.521900,1.521200,1.521700],[1421309700,1.521700,1.521800,1.521300,1.521400],[1421309760,1.521300,1.521900,1.521300,1.521900],[1421309820,1.522000,1.522000,1.521400,1.521500],[1421309880,1.521600,1.521800,1.521400,1.521500],[1421309940,1.521700,1.521700,1.521200,1.521700],[1421310000,1.521600,1.521700,1.521300,1.521600],[1421310060,1.521600,1.521800,1.521200,1.521400],[1421310120,1.521300,1.521700,1.521200,1.521300],[1421310180,1.521200,1.521400,1.520800,1.521000],[1421310240,1.521200,1.521500,1.520900,1.520900],[1421310300,1.520900,1.521200,1.520700,1.521000],[1421310360,1.520900,1.521000,1.520700,1.520900],[1421310420,1.520900,1.521400,1.520700,1.520900],[1421310480,1.520900,1.521300,1.520700,1.521000],[1421310540,1.521000,1.521200,1.520600,1.520900],[1421310600,1.521000,1.521400,1.520800,1.521300],[1421310660,1.521400,1.521500,1.521000,1.521300],[1421310720,1.521200,1.521400,1.520800,1.520800],[1421310780,1.520800,1.521200,1.520300,1.520400],[1421310840,1.520400,1.520900,1.520100,1.520400],[1421310900,1.520300,1.520600,1.520300,1.520300],[1421310960,1.520200,1.520500,1.520100,1.520300],[1421311020,1.520200,1.520400,1.520100,1.520100],[1421311080,1.520300,1.520300,1.520000,1.520100],[1421311140,1.520000,1.520300,1.519900,1.520100],[1421311200,1.520200,1.520600,1.520100,1.520400],[1421311260,1.520500,1.520700,1.520200,1.520300],[1421311320,1.520300,1.520600,1.520000,1.520100],[1421311380,1.520200,1.520300,1.520000,1.520200],[1421311440,1.520200,1.520300,1.519900,1.520000],[1421311500,1.520000,1.520400,1.520000,1.520200],[1421311560,1.520300,1.520700,1.520200,1.520200],[1421311620,1.520300,1.520700,1.520100,1.520600],[1421311680,1.520600,1.520900,1.520400,1.520900],[1421311740,1.520900,1.521400,1.520800,1.521400],[1421311800,1.521400,1.521600,1.521300,1.521400],[1421311860,1.521500,1.521600,1.521200,1.521300],[1421311920,1.521500,1.521700,1.520900,1.521600],[1421311980,1.521600,1.521700,1.521300,1.521400],[1421312040,1.521600,1.521800,1.521500,1.521800],[1421312100,1.521800,1.522000,1.521600,1.521700],[1421312160,1.521900,1.521900,1.521000,1.521400],[1421312220,1.521500,1.521900,1.521200,1.521800],[1421312280,1.521800,1.522000,1.521500,1.521500],[1421312340,1.521400,1.521900,1.521400,1.521500],[1421312400,1.521500,1.521900,1.521400,1.521700],[1421312460,1.521600,1.521700,1.520900,1.520900],[1421312520,1.520900,1.520900,1.520400,1.520600],[1421312580,1.520700,1.520900,1.520600,1.520800],[1421312640,1.520900,1.520900,1.520600,1.520700],[1421312700,1.520900,1.520900,1.520200,1.520400],[1421312760,1.520500,1.520800,1.520400,1.520700],[1421312820,1.520700,1.520800,1.520300,1.520500],[1421312880,1.520700,1.520700,1.520400,1.520600],[1421312940,1.520700,1.520800,1.520300,1.520600],[1421313000,1.520700,1.520900,1.520500,1.520600],[1421313060,1.520700,1.521000,1.520400,1.520900],[1421313120,1.520900,1.521000,1.520700,1.520900],[1421313180,1.520900,1.521300,1.520700,1.521000],[1421313240,1.521200,1.521200,1.520700,1.520700],[1421313300,1.521000,1.521300,1.520600,1.520900]];
    
    var testData2 =
    [
     [1419606480,3167,3167,3166,3166],
     [1419606540,3167,3167,3166,3167],
     [1419606600,3167,3167,3165,3165],
     [1419606660,3164,3164,3158,3160],
     [1419606720,3160,3161,3157,3158],
     [1419606780,3158,3160,3157,3160],
     [1419606840,3160,3161,3160,3161],
     [1419606900,3161,3161,3156,3157],
     [1419606960,3157,3159,3157,3159],
     [1419607020,3159,3161,3159,3159],
     [1419607080,3159,3162,3158,3162],
     [1419607140,3162,3162,3158,3159],
     [1419607200,3159,3160,3158,3160],
     [1419607260,3160,3161,3160,3161],
     [1419607320,3161,3162,3161,3161],
     [1419607380,3161,3161,3159,3160],
     [1419607440,3160,3160,3160,3160],
     [1419607500,3160,3160,3158,3159],
     [1419607560,3159,3159,3159,3159],
     [1419607620,3159,3159,3159,3159],
     [1419607680,3158,3158,3157,3157],
     [1419607740,3157,3157,3156,3156],
     [1419607800,3156,3157,3156,3156],
     [1419607860,3156,3159,3156,3159],
     [1419607920,3159,3160,3158,3159],
     [1419607980,3159,3162,3159,3162],
     [1419608040,3162,3162,3161,3161],
     [1419608100,3161,3162,3161,3161],
     [1419608160,3161,3161,3161,3161],
     [1419608220,3161,3162,3161,3162],
     [1419608280,3163,3164,3163,3164],
     [1419608340,3164,3165,3164,3165],
     [1419608400,3165,3165,3162,3162],
     [1419608460,3162,3162,3160,3160],
     [1419608580,3160,3160,3160,3160],
     [1419608640,3160,3164,3160,3164],
     [1419608700,3164,3164,3161,3161],
     [1419608760,3162,3162,3162,3162],
     [1419608820,3162,3163,3162,3163],
     [1419608880,3163,3163,3160,3160],
     [1419608940,3160,3161,3160,3161],
     [1419609060,3162,3162,3161,3161],
     [1419609120,3161,3161,3160,3160],
     [1419609180,3161,3161,3160,3161],
     [1419609240,3161,3161,3160,3161],
     [1419609300,3161,3162,3161,3161],
     [1419609360,3159,3161,3158,3159],
     [1419609420,3159,3159,3158,3159],
     [1419609480,3158,3158,3156,3158],
     [1419609540,3159,3160,3158,3159],
     [1419609600,3160,3161,3160,3161],
     [1419609660,3161,3162,3160,3160],
     [1419609720,3160,3161,3160,3160],
     [1419609780,3160,3161,3160,3161],
     [1419609840,3161,3162,3161,3161],
     [1419609900,3161,3161,3160,3161],
     [1419609960,3161,3162,3161,3162],
     [1419610020,3162,3165,3162,3165],
     [1419610080,3165,3166,3165,3166],
     [1419610140,3166,3166,3165,3165],
     [1419610200,3165,3165,3164,3164],
     [1419610260,3164,3164,3164,3164],
     [1419610380,3164,3164,3160,3160],
     [1419610440,3160,3162,3160,3161],
     [1419610500,3161,3162,3161,3162],
     [1419610560,3162,3162,3160,3160],
     [1419610620,3160,3162,3160,3162],
     [1419610680,3162,3163,3162,3163],
     [1419610740,3163,3165,3163,3165],
     [1419610800,3165,3165,3164,3164],
     [1419610860,3164,3164,3164,3164],
     [1419610920,3164,3164,3159,3159],
     [1419610980,3159,3162,3159,3161],
     [1419611040,3161,3161,3161,3161],
     [1419611100,3161,3161,3160,3160],
     [1419611160,3159,3160,3158,3159],
     [1419611220,3160,3160,3160,3160],
     [1419611340,3160,3160,3158,3160],
     [1419611400,3160,3160,3158,3158],
     [1419611460,3158,3159,3157,3159],
     [1419611520,3159,3160,3159,3160],
     [1419611580,3160,3162,3160,3162],
     [1419611640,3162,3163,3160,3163],
     [1419611700,3163,3164,3163,3164],
     [1419611760,3165,3168,3165,3166],
     [1419611820,3167,3168,3166,3168],
     [1419611880,3168,3168,3165,3165],
     [1419612000,3165,3166,3164,3165],
     [1419612060,3166,3166,3165,3166],
     [1419612120,3166,3166,3165,3165],
     [1419612180,3165,3166,3165,3166],
     [1419612240,3166,3166,3164,3164],
     [1419612300,3164,3164,3164,3164],
     [1419612360,3164,3164,3164,3164],
     [1419612420,3164,3164,3164,3164],
     [1419612480,3164,3164,3162,3164],
     [1419612540,3164,3164,3162,3162],
     [1419612660,3162,3162,3160,3161],
     [1419612720,3161,3164,3161,3164],
     [1419612780,3164,3165,3164,3164],
     [1419612840,3164,3165,3164,3165],
     [1419612900,3166,3166,3162,3163],
     [1419613020,3163,3163,3162,3162],
     [1419613080,3162,3162,3160,3161],
     [1419613140,3161,3161,3161,3161],
     [1419613200,3161,3162,3160,3160],
     [1419613260,3160,3161,3160,3161],
     [1419613380,3161,3162,3161,3162],
     [1419613500,3162,3162,3160,3160],
     [1419613560,3161,3162,3161,3162],
     [1419613620,3162,3163,3161,3163],
     [1419613680,3163,3163,3162,3163],
     [1419613740,3163,3163,3161,3161],
     [1419613800,3161,3161,3160,3161],
     [1419613860,3161,3161,3160,3160],
     [1419613980,3160,3161,3159,3161],
     [1419614040,3161,3161,3161,3161],
     [1419614100,3161,3161,3161,3161],
     [1419614160,3162,3163,3162,3163],
     [1419614220,3163,3166,3162,3165],
     [1419614280,3165,3166,3164,3165],
     [1419614340,3165,3167,3163,3166],
     [1419614400,3166,3166,3164,3165],
     [1419614460,3165,3165,3164,3164],
     [1419614520,3164,3165,3164,3164],
     [1419614580,3164,3164,3164,3164],
     [1419614640,3164,3165,3164,3165],
     [1419614700,3165,3165,3164,3164],
     [1419614760,3164,3167,3164,3167],
     [1419614820,3168,3169,3167,3168],
     [1419614880,3168,3168,3166,3168],
     [1419614940,3167,3167,3166,3166],
     [1419615000,3166,3166,3162,3162],
     [1419615060,3162,3164,3162,3164],
     [1419615120,3164,3164,3163,3163],
     [1419615180,3163,3163,3162,3162],
     [1419615240,3162,3163,3158,3162],
     [1419615300,3162,3163,3161,3162],
     [1419615360,3162,3164,3161,3164],
     [1419615420,3165,3165,3164,3164],
     [1419615480,3165,3165,3164,3164],
     [1419615540,3165,3165,3165,3165],
     [1419615600,3165,3165,3165,3165],
     [1419615660,3165,3168,3165,3167],
     [1419615720,3168,3168,3165,3165],
     [1419615780,3165,3171,3165,3171],
     [1419615840,3171,3171,3170,3171],
     [1419615900,3170,3171,3170,3171],
     [1419615960,3171,3171,3167,3168],
     [1419616020,3168,3168,3167,3168],
     [1419616080,3168,3169,3168,3169],
     [1419616140,3169,3169,3169,3169],
     [1419616200,3170,3170,3169,3169],
     [1419616320,3169,3169,3169,3169],
     [1419616380,3169,3170,3169,3169],
     [1419616440,3169,3169,3168,3168],
     [1419616500,3168,3168,3168,3168],
     [1419616560,3168,3168,3164,3164],
     [1419616620,3164,3165,3164,3164],
     [1419616680,3164,3165,3163,3164],
     [1419616740,3164,3166,3162,3163],
     [1419616800,3163,3167,3163,3167],
     [1419616860,3167,3168,3167,3168],
     [1419616920,3168,3169,3168,3169],
     [1419616980,3169,3170,3168,3169],
     [1419617040,3168,3169,3168,3168],
     [1419617100,3168,3168,3167,3167],
     [1419617160,3167,3167,3165,3165],
     [1419617220,3165,3169,3165,3167],
     [1419617280,3168,3168,3168,3168],
     [1419617340,3168,3168,3167,3167],
     [1419617400,3168,3168,3166,3166],
     [1419617460,3167,3168,3166,3167],
     [1419617520,3166,3166,3166,3166],
     [1419617580,3166,3167,3166,3167],
     [1419617640,3167,3167,3167,3167],
     [1419617700,3167,3169,3167,3169],
     [1419617760,3169,3169,3169,3169],
     [1419617820,3169,3169,3168,3169],
     [1419617880,3169,3169,3167,3167],
     [1419617940,3167,3167,3166,3167],
     [1419618000,3167,3169,3166,3169],
     [1419618060,3168,3169,3168,3169],
     [1419618180,3169,3169,3166,3166],
     [1419618240,3166,3171,3165,3171],
     [1419618300,3169,3172,3166,3169],
     [1419618360,3166,3167,3165,3165],
     [1419618420,3165,3166,3164,3164],
     [1419618480,3164,3165,3163,3163],
     [1419618540,3163,3165,3163,3164],
     [1419618600,3164,3165,3163,3164],
     [1419618660,3164,3166,3164,3166],
     [1419618720,3167,3167,3167,3167],
     [1419618780,3167,3168,3167,3168],
     [1419618840,3168,3168,3167,3167],
     [1419618900,3167,3167,3167,3167],
     [1419618960,3167,3167,3167,3167],
     [1419619020,3167,3167,3167,3167],
     [1419619080,3167,3167,3166,3166],
     [1419619140,3166,3166,3165,3165],
     [1419619200,3165,3165,3164,3164],
     [1419619260,3164,3164,3164,3164],
     [1419619380,3164,3164,3163,3163],
     [1419619440,3164,3164,3163,3163],
     [1419619500,3164,3165,3164,3164],
     [1419619560,3164,3164,3164,3164],
     [1419619620,3164,3165,3163,3164],
     [1419619680,3164,3164,3163,3163],
     [1419619740,3163,3163,3162,3162],
     [1419619800,3162,3163,3162,3163],
     [1419619860,3163,3164,3163,3164],
     [1419619920,3165,3165,3164,3164],
     [1419619980,3164,3164,3164,3164],
     [1419620040,3164,3164,3164,3164],
     [1419620100,3164,3164,3164,3164],
     [1419620160,3164,3164,3164,3164],
     [1419620220,3165,3165,3165,3165],
     [1419620280,3165,3165,3165,3165],
     [1419620340,3165,3165,3163,3163],
     [1419620400,3163,3163,3162,3162],
     [1419620520,3162,3162,3160,3161],
     [1419620580,3161,3161,3161,3161],
     [1419620640,3161,3161,3161,3161],
     [1419620700,3161,3161,3161,3161],
     [1419620760,3161,3161,3160,3160],
     [1419620820,3161,3161,3160,3160],
     [1419620880,3160,3160,3160,3160],
     [1419620940,3161,3161,3161,3161],
     [1419621000,3161,3161,3159,3160],
     [1419621060,3160,3160,3159,3159],
     [1419621120,3159,3159,3159,3159],
     [1419621180,3159,3159,3158,3159],
     [1419621240,3159,3159,3159,3159],
     [1419621300,3159,3159,3158,3158],
     [1419621420,3159,3161,3159,3160],
     [1419621480,3160,3161,3160,3161],
     [1419621540,3161,3161,3161,3161],
     [1419621660,3161,3161,3160,3160],
     [1419621720,3160,3160,3160,3160],
     [1419621780,3160,3162,3160,3161],
     [1419621840,3161,3162,3161,3162],
     [1419621960,3162,3162,3162,3162],
     [1419622020,3162,3162,3161,3161],
     [1419622080,3161,3161,3161,3161],
     [1419622140,3161,3161,3161,3161],
     [1419622200,3161,3162,3160,3161],
     [1419622260,3161,3161,3161,3161],
     [1419622320,3161,3161,3161,3161],
     [1419622380,3161,3161,3161,3161],
     [1419622440,3161,3161,3160,3160],
     [1419622500,3160,3160,3159,3159],
     [1419622560,3160,3161,3160,3161],
     [1419622620,3162,3162,3161,3161],
     [1419622680,3161,3161,3161,3161],
     [1419622740,3161,3162,3161,3162],
     [1419622800,3162,3162,3162,3162],
     [1419622860,3162,3162,3161,3161],
     [1419622920,3161,3161,3160,3160],
     [1419622980,3160,3160,3158,3158],
     [1419623040,3159,3159,3159,3159],
     [1419623100,3159,3159,3159,3159],
     [1419623160,3159,3160,3159,3160],
     [1419623220,3160,3161,3159,3161],
     [1419623280,3161,3161,3160,3161],
     [1419623340,3161,3161,3158,3158],
     [1419623400,3158,3158,3158,3158],
     [1419623460,3158,3159,3158,3159],
     [1419623520,3159,3159,3156,3156],
     [1419623580,3156,3157,3156,3157],
     [1419623640,3157,3158,3157,3158],
     [1419623700,3159,3159,3159,3159],
     [1419623760,3160,3160,3160,3160],
     [1419623820,3160,3162,3160,3162],
     [1419623880,3162,3163,3159,3163],
     [1419623940,3163,3164,3161,3161],
     [1419624000,3161,3164,3159,3159],
     [1419624060,3159,3160,3159,3160],
     [1419624120,3160,3161,3159,3159],
     [1419624180,3159,3159,3159,3159],
     [1419624240,3159,3159,3159,3159],
     [1419624300,3159,3159,3158,3158],
     [1419624360,3158,3158,3158,3158],
     [1419624420,3158,3158,3157,3158],
     [1419624480,3158,3158,3158,3158],
     [1419624540,3158,3158,3158,3158],
     [1419624600,3157,3158,3156,3156],
     [1419624660,3156,3156,3156,3156],
     [1419624780,3156,3158,3156,3157],
     [1419624840,3157,3157,3156,3157],
     [1419624900,3157,3157,3157,3157],
     [1419624960,3157,3158,3157,3158],
     [1419625020,3158,3158,3157,3157],
     [1419625080,3157,3157,3157,3157],
     [1419625140,3157,3158,3157,3158],
     [1419625320,3157,3157,3157,3157],
     [1419625440,3157,3157,3157,3157],
     [1419625500,3157,3160,3157,3160],
     [1419625560,3160,3160,3159,3159],
     [1419625620,3159,3159,3159,3159],
     [1419625680,3159,3159,3159,3159]
    ] ;
    
    return testData ;
}

function init() {
	var dDate = new Date() ;
    var timezoneOffset = dDate.getTimezoneOffset() ;
    
    chartInfo = {
    	ChartType  : M_CHART_KBAR,
        reDrawType : M_HISRQ_RELOAD,
        symbolInfo : {
            beginTime : 0
        }
    } ;
    
    Highcharts.setOptions({
        global : {
            timezoneOffset : timezoneOffset,
            useUTC : true
        },
    }) ;
    
	var hcConfig = {
        series: getSeries(chartInfo.ChartType),
        yAxis: getYAxis(chartInfo.ChartType),
        
        chart: {
        	marginLeft:  10,
        	marginRight: 40,
        	renderTo: document.getElementById('container'), //指向的div的id属性
        	events: {
                //load: applyGraphGradient
            },
            //zoomType : '',
            resetZoomButton: {
                theme: { display: 'none'}
            }
        },
        
        tooltip : {
            followPointer: true,
            followTouchMove: true
        },
        
        plotOptions : {
            series : {
                enableMouseTracking: false
            },
            candlestick : {
            	pointWidth : 3
    	    }
        },
        
        title: {},
        
        xAxis: {
            gridLineColor: '#333333',
            gridLineWidth: 1,
            gridLineDashStyle: 'longdash' // longdash, solid
        },
        
        navigator: {
            enabled: false,
            series:{id:'navigator'}
        },
        
        scrollbar:{
            enabled : false
        },
        
        rangeSelector: {
            enabled: false,
            buttons: [
            {
                type  : 'minute', //  'millisecond', 'second', 'minute', 'day', 'week', 'month', 'ytd' (year to date), 'year' and 'all'
                count : 400,
                text  : 'M'
            },
            {
                type  : 'day', //  'millisecond', 'second', 'minute', 'day', 'week', 'month', 'ytd' (year to date), 'year' and 'all'
                count : 400,
                text  : 'Day'
            }],
        	selected: 0,
        	inputEnabled: false // 设置是否打开日期范围输入框
    	},
    	
    	credits : {
       		href: '',
        	text: ' ',
        	style: {
            	color: '#999900'
        	}
    	}
	};

    setTheme() ;

    chart = new Highcharts.StockChart(
        hcConfig
    );
//     chart.curChartType = chartInfo.ChartType ; // 记录当前的图表样式，当发生样式切换时，能够根据该设置正确的删除 series

} ;

$(function () {
  init() ;
  
  //testDraw() ;
});

